// Happy Pride Month!!!!!!!!!!!!!!!!

freeslot("MT_PRIDESPAWNER", "SPR_PRDE")

mobjinfo[MT_PRIDESPAWNER] = {
	doomednum = 3503,
	spawnstate = S_INVISIBLE,
	flags = MF_NOGRAVITY
}

local function SpawnPrideFlag(mo)
	local flag = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	flag.tics = -1
	flag.sprite = SPR_PRDE
	flag.frame = FF_PAPERSPRITE | P_RandomRange(A, J) | FF_TRANS50
	flag.angle = mo.angle
	flag.flags = MF_MISSILE|MF_NOBLOCKMAP|MF_NOGRAVITY
	
	P_InstaThrust(flag, flag.angle, P_RandomRange(7, 9)*FRACUNIT)
	
	mo.countdown = P_RandomRange(5, 8) * TICRATE
end

addHook("MobjThinker", function(mo)
	if not mo.started
		if P_RandomChance(FRACUNIT/3)
			SpawnPrideFlag(mo)
		else
			mo.countdown = P_RandomRange(3, 6) * TICRATE
		end
		
		mo.started = true
		mo.dir = P_RandomChance(FRACUNIT/2) and FRACUNIT or -FRACUNIT
	elseif not mo.countdown
		SpawnPrideFlag(mo)
	end
	
	if mo.z == mo.ceilingz or mo.z == mo.floorz
		mo.dir = $ * -1
	end
	
	mo.z = $ + mo.dir
	mo.countdown = max(0, $ - 1)
end, MT_PRIDESPAWNER)